diff --git a/web/karma.conf.js b/web/karma.conf.js
index 82f19b72..ac35838b 100644
--- a/web/karma.conf.js
+++ b/web/karma.conf.js
@@ -33,7 +33,6 @@ module.exports = function (config) {
       }),
     ],
     files: [
-      'pgadmin/static/bundle/slickgrid.js',
       {pattern: 'pgadmin/static/**/*.js', included: false, watched: true},
       {pattern: 'pgadmin/browser/static/js/**/*.js', included: false, watched: true},
       {pattern: 'regression/javascript/**/*.js', watched: true},
@@ -50,7 +49,6 @@ module.exports = function (config) {
     preprocessors: {
       'pgadmin/**/js/**/*.js?': ['sourcemap'],
       'regression/javascript/**/*.js': ['webpack', 'sourcemap'],
-      'pgadmin/static/bundle/slickgrid.js': ['webpack', 'sourcemap'],
     },
 
     // optionally, configure the reporter
diff --git a/web/pgadmin/browser/static/js/frame.js b/web/pgadmin/browser/static/js/frame.js
index d130211b..8a153774 100644
--- a/web/pgadmin/browser/static/js/frame.js
+++ b/web/pgadmin/browser/static/js/frame.js
@@ -18,7 +18,7 @@ define([
   pgAdmin.Browser.Frame = function(options) {
     var defaults = [
       'name', 'title', 'width', 'height', 'showTitle', 'isCloseable',
-      'isPrivate', 'url', 'icon', 'onCreate', 'isLayoutMember',
+      'isPrivate', 'url', 'icon', 'onCreate', 'isLayoutMember', 'isRenamable',
     ];
     _.extend(this, _.pick(options, defaults));
   };
diff --git a/web/pgadmin/static/js/Dialogs/RenamePanelContent.jsx b/web/pgadmin/static/js/Dialogs/RenamePanelContent.jsx
new file mode 100644
index 00000000..102f42ab
--- /dev/null
+++ b/web/pgadmin/static/js/Dialogs/RenamePanelContent.jsx
@@ -0,0 +1,115 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+import _ from 'lodash';
+import React, { useState, useRef, useEffect } from 'react';
+import PropTypes from 'prop-types';
+
+import { Box } from '@material-ui/core';
+import CloseIcon from '@material-ui/icons/CloseRounded';
+import CheckRoundedIcon from '@material-ui/icons/CheckRounded';
+
+import pgAdmin from 'sources/pgadmin';
+import gettext from 'sources/gettext';
+
+import { DefaultButton, PrimaryButton } from '../components/Buttons';
+import { useModalStyles } from '../helpers/ModalProvider';
+import { FormFooterMessage, InputText, MESSAGE_TYPE } from '../components/FormComponents';
+import { setDebuggerTitle } from '../../../tools/debugger/static/js/debugger_utils';
+import * as queryToolPanelTitleFunc from '../../../tools/sqleditor/static/js/sqleditor_title';
+import * as queryToolPanelViewDataFunc from '../../../tools/sqleditor/static/js/show_view_data';
+
+export default function RenamePanelContent({ closeModal, panel, title, preferences, setHeight, tabType, data }) {
+  const classes = useModalStyles();
+  const containerRef = useRef();
+  const firstEleRef = useRef();
+  const okBtnRef = useRef();
+  const [formData, setFormData] = useState({
+    title: title
+  });
+
+  const onTextChange = (e, id) => {
+    let val = e;
+    if (e && e.target) {
+      val = e.target.value;
+    }
+    setFormData((prev) => ({ ...prev, [id]: val }));
+  };
+
+  const onKeyDown = (e) => {
+    // If enter key is pressed then click on OK button
+    if (e.key === 'Enter') {
+      okBtnRef.current?.click();
+    }
+  };
+
+  useEffect(() => {
+    setTimeout(() => {
+      firstEleRef.current && firstEleRef.current.focus();
+    }, 350);
+  }, [firstEleRef.current]);
+
+  useEffect(() => {
+    setHeight?.(containerRef.current?.offsetHeight);
+  }, [containerRef.current, formData]);
+
+  return (
+    <Box display="flex" flexDirection="column" className={classes.container} ref={containerRef}>
+      <Box flexGrow="1" p={2}>
+
+        <Box marginTop='12px'>
+          <InputText inputRef={firstEleRef} type="text" value={formData['title']} controlProps={{ maxLength: null }}
+            onChange={(e) => onTextChange(e, 'title')} onKeyDown={(e) => onKeyDown(e)} />
+        </Box>
+
+        <FormFooterMessage type={MESSAGE_TYPE.ERROR} message={formData['title'].length == 0 ? gettext('Title cannot be empty') : ''} closable={false} style={{
+          position: 'unset', padding: '12px 0px 0px'
+        }} />
+      </Box>
+      <Box className={classes.footer}>
+        <DefaultButton data-test="close" startIcon={<CloseIcon />} onClick={() => {
+          closeModal();
+        }} >{gettext('Cancel')}</DefaultButton>
+        <PrimaryButton ref={okBtnRef} data-test="save" className={classes.margin} disabled={formData['title'].length == 0 ? true : false} startIcon={<CheckRoundedIcon />} onClick={() => {
+          if (tabType == 'debugger') {
+            setDebuggerTitle(panel, preferences, data.function_name, data.schema_name, data.database_name, _.escape(formData['title']), pgAdmin.Browser);
+          } else if (tabType == 'querytool') {
+            let selected_item = pgAdmin.Browser.tree.selected();
+            let panel_titles = '';
+
+            if (data.is_query_tool) {
+              panel_titles = queryToolPanelTitleFunc.getPanelTitle(pgAdmin.Browser, selected_item, formData['title']);
+            } else {
+              panel_titles = queryToolPanelViewDataFunc.generateViewDataTitle(pgAdmin.Browser, selected_item, formData['title']);
+            }
+            // Set title to the selected tab.
+            if (data.is_dirty_editor) {
+              panel_titles = panel_titles + ' *';
+            }
+            queryToolPanelTitleFunc.setQueryToolDockerTitle(panel, data.is_query_tool, panel_titles, data.is_file);
+          } else {
+            panel.title(_.escape(formData.title));
+          }
+          closeModal();
+        }} >{gettext('OK')}</PrimaryButton>
+      </Box>
+    </Box>
+  );
+}
+
+RenamePanelContent.propTypes = {
+  closeModal: PropTypes.func,
+  data: PropTypes.object,
+  setHeight: PropTypes.func,
+  panel: PropTypes.object,
+  title: PropTypes.string,
+  preferences: PropTypes.object,
+  tabType: PropTypes.string,
+  'panel.title': PropTypes.string,
+};
diff --git a/web/pgadmin/static/js/Dialogs/index.jsx b/web/pgadmin/static/js/Dialogs/index.jsx
index ae4f963b..ee2ca73d 100644
--- a/web/pgadmin/static/js/Dialogs/index.jsx
+++ b/web/pgadmin/static/js/Dialogs/index.jsx
@@ -22,6 +22,7 @@ import ChangePasswordContent from './ChangePasswordContent';
 import NamedRestoreContent from './NamedRestoreContent';
 import ChangeOwnershipContent from './ChangeOwnershipContent';
 import UrlDialogContent from './UrlDialogContent';
+import RenamePanelContent from './RenamePanelContent';
 
 function mountDialog(title, getDialogContent, docker=undefined, width, height) {
   // Register dialog panel
@@ -353,3 +354,29 @@ export function showUrlDialog() {
   { isFullScreen: false, isResizeable: true, showFullScreen: true, isFullWidth: true,
     dialogWidth: width || pgAdmin.Browser.stdW.md, dialogHeight: height || pgAdmin.Browser.stdH.md});
 }
+
+export function showRenamePanel() {
+  let title = arguments[0],
+    preferences = arguments[1],
+    panel = arguments[2],
+    tabType= arguments[3],
+    data= arguments[4];
+
+  mountDialog(gettext(`Rename Panel ${_.escape(title)}`), (onClose, setNewSize)=> {
+    return <Theme>
+      <RenamePanelContent
+        setHeight={(containerHeight)=>{
+          setNewSize(pgAdmin.Browser.stdW.md, containerHeight);
+        }}
+        closeModal={()=>{
+          onClose();
+        }}
+        panel={panel}
+        tabType={tabType}
+        title={title}
+        data={data}
+        preferences={preferences}
+      />
+    </Theme>;
+  });
+}
diff --git a/web/pgadmin/static/js/Theme/dark.js b/web/pgadmin/static/js/Theme/dark.js
index e36072a6..457550b3 100644
--- a/web/pgadmin/static/js/Theme/dark.js
+++ b/web/pgadmin/static/js/Theme/dark.js
@@ -103,6 +103,13 @@ export default function(basicSettings) {
       textMuted: '#8A8A8A',
       erdCanvasBg: '#303030',
       erdGridColor: '#444952',
+      schemaDiff: {
+        diffRowColor: '#807a48',
+        sourceRowColor: '#402025',
+        targetRowColor: '#6b5438',
+        diffColorFg: '#d4d4d4',
+        diffSelectFG: '#d4d4d4'
+      }
     }
   });
 }
diff --git a/web/pgadmin/static/js/Theme/high_contrast.js b/web/pgadmin/static/js/Theme/high_contrast.js
index 9c875737..482c2496 100644
--- a/web/pgadmin/static/js/Theme/high_contrast.js
+++ b/web/pgadmin/static/js/Theme/high_contrast.js
@@ -101,6 +101,13 @@ export default function(basicSettings) {
       textMuted: '#8b9cad',
       erdCanvasBg: '#010B15',
       erdGridColor: '#1F2932',
+      schemaDiff: {
+        diffRowColor: '#CFC56E',
+        sourceRowColor: '#EE97A5',
+        targetRowColor: '#FFAD65',
+        diffColorFg: '#FFFFFF',
+        diffSelectFG: '#010B15'
+      }
     }
   });
 }
diff --git a/web/pgadmin/static/js/Theme/standard.js b/web/pgadmin/static/js/Theme/standard.js
index 66e24ee3..1fea4e6b 100644
--- a/web/pgadmin/static/js/Theme/standard.js
+++ b/web/pgadmin/static/js/Theme/standard.js
@@ -121,6 +121,13 @@ export default function(basicSettings) {
           color: '#FFFFFF',
           bg: '#880000'
         },
+      },
+      schemaDiff: {
+        diffRowColor: '#fff9c4',
+        sourceRowColor: '#ffebee',
+        targetRowColor: '#fbe3bf',
+        diffColorFg: '#222',
+        diffSelectFG: '#222'
       }
     }
   });
diff --git a/web/pgadmin/static/js/components/Loader.jsx b/web/pgadmin/static/js/components/Loader.jsx
index 48dd7f95..fda2d3b0 100644
--- a/web/pgadmin/static/js/components/Loader.jsx
+++ b/web/pgadmin/static/js/components/Loader.jsx
@@ -37,6 +37,7 @@ const useStyles = makeStyles((theme)=>({
   },
   message: {
     marginLeft: '0.5rem',
+    fontSize: '16px',
   }
 }));
 
diff --git a/web/pgadmin/static/js/components/PgReactDataGrid.jsx b/web/pgadmin/static/js/components/PgReactDataGrid.jsx
index e37e5d36..7c2564c1 100644
--- a/web/pgadmin/static/js/components/PgReactDataGrid.jsx
+++ b/web/pgadmin/static/js/components/PgReactDataGrid.jsx
@@ -128,7 +128,7 @@ CustomRow.propTypes = {
 };
 
 export default function PgReactDataGrid({gridRef, className, hasSelectColumn=true, onItemEnter, onItemSelect,
-  onItemClick, noRowsText, ...props}) {
+  onItemClick, noRowsText, noRowsIcon,...props}) {
   const classes = useStyles();
   let finalClassName = [classes.root];
   hasSelectColumn && finalClassName.push(classes.hasSelectColumn);
@@ -142,7 +142,7 @@ export default function PgReactDataGrid({gridRef, className, hasSelectColumn=tru
         components={{
           sortIcon: CutomSortIcon,
           rowRenderer: CustomRow,
-          noRowsFallback: <Box textAlign="center" gridColumn="1/-1" p={1}>{noRowsText || gettext('No rows found.')}</Box>,
+          noRowsFallback: <Box textAlign="center" gridColumn="1/-1" p={1}>{noRowsIcon}{noRowsText || gettext('No rows found.')}</Box>,
         }}
         {...props}
       />
@@ -158,5 +158,6 @@ PgReactDataGrid.propTypes = {
   onItemEnter: PropTypes.func,
   onItemSelect: PropTypes.func,
   onItemClick: PropTypes.func,
-  noRowsText: PropTypes.string
+  noRowsText: PropTypes.string,
+  noRowsIcon: PropTypes.elementType
 };
diff --git a/web/pgadmin/static/js/helpers/Layout.jsx b/web/pgadmin/static/js/helpers/Layout.jsx
index 926904a2..fc0155b1 100644
--- a/web/pgadmin/static/js/helpers/Layout.jsx
+++ b/web/pgadmin/static/js/helpers/Layout.jsx
@@ -67,6 +67,12 @@ const useStyles = makeStyles((theme)=>({
       '& .dock-tabpane': {
         backgroundColor: theme.palette.background.default,
         color: theme.palette.text.primary,
+      },
+      '& #id-schema-diff': {
+        overflowY: 'auto'
+      },
+      '& #id-results': {
+        overflowY: 'auto'
       }
     },
     '& .dock-tab': {
diff --git a/web/pgadmin/tools/debugger/static/js/DebuggerModule.js b/web/pgadmin/tools/debugger/static/js/DebuggerModule.js
index 2911c6fb..68ef75bf 100644
--- a/web/pgadmin/tools/debugger/static/js/DebuggerModule.js
+++ b/web/pgadmin/tools/debugger/static/js/DebuggerModule.js
@@ -16,7 +16,6 @@ import gettext from 'sources/gettext';
 import { sprintf, registerDetachEvent } from 'sources/utils';
 import url_for from 'sources/url_for';
 import pgWindow from 'sources/window';
-import alertify from 'pgadmin.alertifyjs';
 import Kerberos from 'pgadmin.authenticate.kerberos';
 
 import { refresh_db_node } from 'tools/sqleditor/static/js/sqleditor_title';
@@ -28,6 +27,7 @@ import FunctionArguments from './debugger_ui';
 import ModalProvider from '../../../../static/js/helpers/ModalProvider';
 import DebuggerComponent from './components/DebuggerComponent';
 import Theme from '../../../../static/js/Theme';
+import { showRenamePanel } from '../../../../static/js/Dialogs';
 
 export default class DebuggerModule {
   static instance;
@@ -713,20 +713,13 @@ export default class DebuggerModule {
   }
 
   panel_rename_event(panel_data, panel, treeInfo) {
-    alertify.prompt('', panel_data.$titleText[0].textContent,
-      // We will execute this function when user clicks on the OK button
-      function (evt, value) {
-        if (value) {
-          // Remove the leading and trailing white spaces.
-          value = value.trim();
-          let preferences = this.pgBrowser.get_preferences_for_module('browser');
-          var name = getAppropriateLabel(treeInfo);
-          setDebuggerTitle(panel, preferences, name, treeInfo.schema.label, treeInfo.database.label, value, this.pgBrowser);
-        }
-      },
-      // We will execute this function when user clicks on the Cancel
-      // button.  Do nothing just close it.
-      function (evt) { evt.cancel = false; }
-    ).set({ 'title': gettext('Rename Panel') });
+    let name = getAppropriateLabel(treeInfo);
+    let preferences = this.pgBrowser.get_preferences_for_module('browser');
+    let data = {
+      function_name: name,
+      schema_name: treeInfo.schema.label,
+      database_name: treeInfo.database.label
+    };
+    showRenamePanel(panel_data.$titleText[0].textContent, preferences, panel, 'debugger', data);
   }
 }
diff --git a/web/pgadmin/tools/debugger/static/js/components/DebuggerArgumentComponent.jsx b/web/pgadmin/tools/debugger/static/js/components/DebuggerArgumentComponent.jsx
index ab5b3292..16daa8b7 100644
--- a/web/pgadmin/tools/debugger/static/js/components/DebuggerArgumentComponent.jsx
+++ b/web/pgadmin/tools/debugger/static/js/components/DebuggerArgumentComponent.jsx
@@ -22,7 +22,6 @@ import gettext from 'sources/gettext';
 import * as commonUtils from 'sources/utils';
 import pgAdmin from 'sources/pgadmin';
 import Loader from 'sources/components/Loader';
-import Alertify from 'pgadmin.alertifyjs';
 
 import SchemaView from '../../../../../static/js/SchemaView';
 import getApiInstance from '../../../../../static/js/api_instance';
@@ -31,7 +30,7 @@ import { getAppropriateLabel, setDebuggerTitle } from '../debugger_utils';
 import Notify from '../../../../../static/js/helpers/Notifier';
 import { DebuggerArgumentSchema } from './DebuggerArgs.ui';
 import { DEBUGGER_ARGS } from '../DebuggerConstants';
-
+import { showRenamePanel } from '../../../../../static/js/Dialogs';
 
 
 const useStyles = makeStyles((theme) =>
@@ -677,7 +676,6 @@ export default function DebuggerArgumentComponent({ debuggerInfo, restartDebug,
   }
 
   function startDebugging() {
-    var self = this;
     setLoaderText('Starting debugger.');
     try {
       /* Initialize the target once the debug button is clicked and create asynchronous connection
@@ -759,20 +757,7 @@ export default function DebuggerArgumentComponent({ debuggerInfo, restartDebug,
 
               // Panel Rename event
               panel.on(wcDocker.EVENT.RENAME, function (panel_data) {
-                Alertify.prompt('', panel_data.$titleText[0].textContent,
-                  // We will execute this function when user clicks on the OK button
-                  function (evt, value) {
-                    if (value) {
-                      // Remove the leading and trailing white spaces.
-                      value = value.trim();
-                      var name = getAppropriateLabel(treeInfo);
-                      setDebuggerTitle(panel, self.preferences, name, treeInfo.schema.label, treeInfo.database.label, value, pgAdmin.Browser);
-                    }
-                  },
-                  // We will execute this function when user clicks on the Cancel
-                  // button.  Do nothing just close it.
-                  function (evt) { evt.cancel = false; }
-                ).set({ 'title': gettext('Rename Panel') });
+                panelRenameEvent(panel_data, panel, treeInfo);
               });
             }
 
@@ -861,6 +846,17 @@ export default function DebuggerArgumentComponent({ debuggerInfo, restartDebug,
 
   }
 
+  function panelRenameEvent(panel_data, panel, treeInfo) {
+    let name = getAppropriateLabel(treeInfo);
+    let preferences = pgAdmin.Browser.get_preferences_for_module('browser');
+    let data = {
+      function_name: name,
+      schema_name: treeInfo.schema.label,
+      database_name: treeInfo.database.label
+    };
+    showRenamePanel(panel_data.$titleText[0].textContent, preferences, panel, 'debugger', data);
+  }
+
   return (
     <Box className={classes.root}>
       <Box className={classes.body}>
diff --git a/web/pgadmin/tools/schema_diff/__init__.py b/web/pgadmin/tools/schema_diff/__init__.py
index 6f50f598..7845a51d 100644
--- a/web/pgadmin/tools/schema_diff/__init__.py
+++ b/web/pgadmin/tools/schema_diff/__init__.py
@@ -129,18 +129,7 @@ def panel(trans_id, editor_title):
         trans_id=trans_id,
         requirejs=True,
         basejs=True,
-        editor_title=editor_title
-    )
-
-
-@blueprint.route("/schema_diff.js")
-@login_required
-def script():
-    """render the required javascript"""
-    return Response(
-        response=render_template("schema_diff/js/schema_diff.js", _=gettext),
-        status=200,
-        mimetype=MIMETYPE_APP_JS
+        editor_title=editor_title,
     )
 
 
diff --git a/web/pgadmin/tools/schema_diff/static/js/SchemaDiffConstants.js b/web/pgadmin/tools/schema_diff/static/js/SchemaDiffConstants.js
new file mode 100644
index 00000000..69495172
--- /dev/null
+++ b/web/pgadmin/tools/schema_diff/static/js/SchemaDiffConstants.js
@@ -0,0 +1,65 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+import gettext from 'sources/gettext';
+
+export const PANELS = {
+  SCHEMADIFF: 'id-schema-diff',
+  RESULTS: 'id-results',
+};
+
+export const TYPE = {
+  SOURCE: 1,
+  TARGET: 2
+};
+
+export const MENUS = {
+  COMPARE: 'schema-diff-compare',
+  GENERATE_SCRIPT: 'schema-diff-generate-script',
+  FILTER: 'schema-diff-filter'
+};
+
+export const STYLE_CONSTANT = {
+  IDENTICAL: 'identical',
+  DIFFERENT :'different',
+  SOURCE_ONLY: 'source',
+  TARGET_ONLY: 'target'
+};
+
+export const MENUS_COMPARE_CONSTANT = {
+  COMPARE_IGNORE_OWNER: 1,
+  COMPARE_IGNORE_WHITESPACE: 2
+};
+
+export const MENUS_FILTER_CONSTANT = {
+  FILTER_IDENTICAL: 1,
+  FILTER_DIFFERENT: 2,
+  FILTER_SOURCE_ONLY: 3,
+  FILTER_TARGET_ONLY: 4,
+};
+
+export const SCHEMA_DIFF_EVENT = {
+  TRIGGER_SELECT_SERVER: 'TRIGGER_SELECT_SERVER',
+  TRIGGER_SELECT_DATABASE: 'TRIGGER_SELECT_DATABASE',
+  TRIGGER_SELECT_SCHEMA: 'TRIGGER_SELECT_DATABASE',
+
+  TRIGGER_COMPARE_DIFF: 'TRIGGER_COMPARE_DIFF',
+  TRIGGER_GENERATE_SCRIPT: 'TRIGGER_GENERATE_SCRIPT',
+  TRIGGER_CHANGE_FILTER: 'TRIGGER_CHANGE_FILTER',
+
+  TRIGGER_CHANGE_RESULT_SQL: 'TRIGGER_CHANGE_RESULT_SQL',
+  TRIGGER_ROW_SELECT: 'TRIGGER_ROW_SELECT',
+};
+
+export const FILTER_NAME = {
+  IDENTICAL : gettext('Identical'),
+  DIFFERENT : gettext('Different'),
+  SOURCE_ONLY: gettext('Source Only'),
+  TARGET_ONLY: gettext('Target Only')
+};
diff --git a/web/pgadmin/tools/schema_diff/static/js/SchemaDiffModule.js b/web/pgadmin/tools/schema_diff/static/js/SchemaDiffModule.js
new file mode 100644
index 00000000..6e958afe
--- /dev/null
+++ b/web/pgadmin/tools/schema_diff/static/js/SchemaDiffModule.js
@@ -0,0 +1,165 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+
+import React from 'react';
+import ReactDOM from 'react-dom';
+
+import gettext from 'sources/gettext';
+import url_for from 'sources/url_for';
+import pgWindow from 'sources/window';
+import { registerDetachEvent } from 'sources/utils';
+
+import { _set_dynamic_tab } from '../../../sqleditor/static/js/show_query_tool';
+import getApiInstance from '../../../../static/js/api_instance';
+import Theme from '../../../../static/js/Theme';
+import ModalProvider from '../../../../static/js/helpers/ModalProvider';
+import Notify from '../../../../static/js/helpers/Notifier';
+import SchemaDiffComponent from './components/SchemaDiffComponent';
+import { showRenamePanel } from '../../../../static/js/Dialogs';
+
+
+export default class SchemaDiff {
+  static instance;
+
+  static getInstance(...args) {
+    if (!SchemaDiff.instance) {
+      SchemaDiff.instance = new SchemaDiff(...args);
+    }
+    return SchemaDiff.instance;
+  }
+
+  constructor(pgAdmin, pgBrowser) {
+    this.pgAdmin = pgAdmin;
+    this.pgBrowser = pgBrowser;
+    this.wcDocker = window.wcDocker;
+    this.api = getApiInstance();
+  }
+
+  init() {
+    let self = this;
+    if (self.initialized)
+      return;
+    self.initialized = true;
+    // Define the nodes on which the menus to be appear
+    self.pgBrowser.add_menus([{
+      name: 'schema_diff',
+      module: self,
+      applies: ['tools'],
+      callback: 'showSchemaDiffTool',
+      priority: 1,
+      label: gettext('Schema Diff'),
+      enable: true,
+      below: true,
+    }]);
+
+    /* Create and load the new frame required for schema diff panel */
+    self.frame = new self.pgBrowser.Frame({
+      name: 'frm_schemadiff',
+      title: gettext('Schema Diff'),
+      showTitle: true,
+      isCloseable: true,
+      isRenamable: true,
+      isPrivate: true,
+      icon: 'pg-font-icon icon-compare',
+      url: 'about:blank',
+    });
+
+    /* Cache may take time to load for the first time. Keep trying till available */
+    let cacheIntervalId = setInterval(function () {
+      if (self.pgBrowser.preference_version() > 0) {
+        self.preferences = self.pgBrowser.get_preferences_for_module('schema_diff');
+        clearInterval(cacheIntervalId);
+      }
+    }, 0);
+
+    self.pgBrowser.onPreferencesChange('schema_diff', function () {
+      self.preferences = self.pgBrowser.get_preferences_for_module('schema_diff');
+    });
+
+    self.frame.load(self.pgBrowser.docker);
+  }
+
+  showSchemaDiffTool() {
+    let self = this;
+
+    self.api({
+      url: url_for('schema_diff.initialize', null),
+      method: 'GET',
+    })
+      .then(function (res) {
+        self.trans_id = res.data.data.schemaDiffTransId;
+        res.data.data.panel_title = gettext('Schema Diff');
+        self.launchSchemaDiff(res.data.data);
+      })
+      .catch(function (error) {
+        Notify.error(gettext(`Error in schema diff initialize ${error.response.data}`));
+      });
+  }
+
+  launchSchemaDiff(data) {
+    let self = this;
+    let panelTitle = data.panel_title,
+      trans_id = data.schemaDiffTransId,
+      panelTooltip = '';
+
+    let url_params = {
+        'trans_id': trans_id,
+        'editor_title': panelTitle,
+      },
+      baseUrl = url_for('schema_diff.panel', url_params);
+
+    let browserPreferences = this.pgBrowser.get_preferences_for_module('browser');
+    let openInNewTab = browserPreferences.new_browser_tab_open;
+    if (openInNewTab && openInNewTab.includes('schema_diff')) {
+      window.open(baseUrl, '_blank');
+      // Send the signal to runtime, so that proper zoom level will be set.
+      setTimeout(function () {
+        this.pgBrowser.send_signal_to_runtime('Runtime new window opened');
+      }, 500);
+    } else {
+      this.pgBrowser.Events.once(
+        'pgadmin-browser:frame:urlloaded:frm_schemadiff',
+        function (frame) {
+          frame.openURL(baseUrl);
+        });
+      let propertiesPanel = this.pgBrowser.docker.findPanels('properties'),
+        schemaDiffPanel = this.pgBrowser.docker.addPanel('frm_schemadiff', this.wcDocker.DOCK.STACKED, propertiesPanel[0]);
+
+      registerDetachEvent(schemaDiffPanel);
+
+      // Panel Rename event
+      schemaDiffPanel.on(self.wcDocker.EVENT.RENAME, function (panel_data) {
+        self.panel_rename_event(panel_data, schemaDiffPanel, browserPreferences);
+      });
+
+      _set_dynamic_tab(this.pgBrowser, browserPreferences['dynamic_tabs']);
+      // Set panel title and icon
+      schemaDiffPanel.title('<span title="' + panelTooltip + '">' + panelTitle + '</span>');
+      schemaDiffPanel.icon('pg-font-icon icon-compare');
+      schemaDiffPanel.focus();
+
+    }
+  }
+
+  panel_rename_event(panel_data, panel) {
+    showRenamePanel(panel_data.$titleText[0].textContent, null, panel);
+  }
+
+  load(container, trans_id) {
+    ReactDOM.render(
+      <Theme>
+        <ModalProvider>
+          <SchemaDiffComponent params={{ transId: trans_id, pgAdmin: pgWindow.pgAdmin }}></SchemaDiffComponent>
+        </ModalProvider>
+      </Theme>,
+      container
+    );
+  }
+
+}
diff --git a/web/pgadmin/tools/schema_diff/static/js/components/InputComponent.jsx b/web/pgadmin/tools/schema_diff/static/js/components/InputComponent.jsx
new file mode 100644
index 00000000..440d2d8e
--- /dev/null
+++ b/web/pgadmin/tools/schema_diff/static/js/components/InputComponent.jsx
@@ -0,0 +1,143 @@
+/////////////////////////////////////////////////////////////
+//
+// pgAdmin 4 - PostgreSQL Tools
+//
+// Copyright (C) 2013 - 2022, The pgAdmin Development Team
+// This software is released under the PostgreSQL Licence
+//
+//////////////////////////////////////////////////////////////
+import _ from 'lodash';
+import PropTypes from 'prop-types';
+
+import React, { useContext, useState } from 'react';
+
+import { Box, Grid, Typography } from '@material-ui/core';
+import { makeStyles } from '@material-ui/styles';
+
+import { InputSelect } from '../../../../../static/js/components/FormComponents';
+import { SchemaDiffEventsContext } from './SchemaDiffComponent';
+import { SCHEMA_DIFF_EVENT } from '../SchemaDiffConstants';
+
+
+const useStyles = makeStyles(() => ({
+  root: {
+    padding: '0rem'
+  },
+  spanLabel: {
+    alignSelf: 'center',
+    marginRight: '4px',
+  },
+  inputLabel: {
+    padding: '0.3rem',
+  },
+}));
+
+export function InputComponent({ label, serverList, databaseList, schemaList, diff_type, selectedSid = null, selectedDid=null, selectedScid=null }) {
+
+  const classes = useStyles();
+  const [selectedServer, setSelectedServer] = useState(selectedSid);
+  const [selectedDatabase, setSelectedDatabase] = useState(selectedDid);
+  const [selectedSchema, setSelectedSchema] = useState(selectedScid);
+  const eventBus = useContext(SchemaDiffEventsContext);
+  const [disableDBSelection, setDisableDBSelection] = useState(selectedSid == null ? true : false);
+  const [disableSchemaSelection, setDisableSchemaSelection] = useState(selectedDid == null ? true : false);
+  const changeServer = (selectedOption) => {
+    setDisableDBSelection(false);
+    setSelectedServer(selectedOption);
+    // Reset the Database selection if user deselect server from DD
+    if(selectedOption == null){
+      setSelectedDatabase(null);
+      setDisableDBSelection(true);
+      setSelectedSchema(null);
+      setDisableSchemaSelection(true);
+    }
+
+    eventBus.fireEvent(SCHEMA_DIFF_EVENT.TRIGGER_SELECT_SERVER, { selectedOption, diff_type, serverList });
+  };
+
+  const changeDatabase = (selectedDB) => {
+    setSelectedDatabase(selectedDB);
+    setDisableSchemaSelection(false);
+    // Reset the Schema selection if user deselect database from DD
+    if(selectedDB == null){
+      setSelectedSchema(null);
+      setDisableSchemaSelection(true);
+    }
+    eventBus.fireEvent(SCHEMA_DIFF_EVENT.TRIGGER_SELECT_DATABASE, {selectedServer, selectedDB, diff_type, databaseList});
+  };
+
+  const changeSchema = (selectedSC) => {
+    setSelectedSchema(selectedSC);
+    eventBus.fireEvent(SCHEMA_DIFF_EVENT.TRIGGER_SELECT_SCHEMA, { selectedSC, diff_type });
+  };
+
+  return (
+    <Box className={classes.root}>
+      <Grid
+        container
+        direction="row"
+        alignItems="center"
+        key={_.uniqueId('c')}
+      >
+        <Grid item lg={2} md={2} sm={2} xs={2} className={classes.inputLabel} key={_.uniqueId('c')}>
+          <Typography id={label}>{label}</Typography>
+        </Grid>
+        <Grid item lg={4} md={4} sm={4} xs={4} className={classes.inputLabel} key={_.uniqueId('c')}>
+          <InputSelect
+            options={serverList}
+            onChange={changeServer}
+            value={selectedServer}
+            controlProps={
+              {
+                placeholder: 'Select server...'
+              }
+            }
+            key={'server_' + diff_type}
+          ></InputSelect>
+        </Grid>
+
+        <Grid item lg={3} md={3} sm={3} xs={3} className={classes.inputLabel} key={_.uniqueId('c')}>
+          <InputSelect
+            options={databaseList}
+            onChange={changeDatabase}
+            value={selectedDatabase}
+            controlProps={
+              {
+                placeholder: 'Select Database...'
+              }
+            }
+            key={'database_' + diff_type}
+            readonly={disableDBSelection}
+          ></InputSelect>
+        </Grid>
+
+        <Grid item lg={3} md={3} sm={3} xs={3} className={classes.inputLabel} key={_.uniqueId('c')}>
+          <InputSelect
+            options={schemaList}
+            onChange={changeSchema}
+            value={selectedSchema}
+            controlProps={
+              {
+                placeholder: 'Select Schema...'
+              }
+            }
+            key={'schema' + diff_type}
+            readonly={disableSchemaSelection}
+          ></InputSelect>
+        </Grid>
+      </Grid>
+
+    </Box >
+  );
+}
+
+InputComponent.propTypes = {
+  label: PropTypes.string,
+  serverList: PropTypes.array, 
+  databaseList:PropTypes.array, 
+  schemaList:PropTypes.array, 
+  diff_type:PropTypes.number,
+  selectedSid: PropTypes.number,
+  selectedDid: PropTypes.number,
+  selectedScid:PropTypes.number,
+};
